# Class DigestInputStream

java.lang.Object
java.io.InputStream
java.io.FilterInputStream
java.security.DigestInputStream

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

public class DigestInputStream extends FilterInputStream
A transparent stream that updates the associated message digest using the bits going through the stream.

To complete the message digest computation, call one of the `digest` methods on the associated message digest after your calls to one of this digest input stream's `read` methods.

It is possible to turn this stream on or off (see `on`). When it is on, a call to one of the `read` methods results in an update on the message digest. But when it is off, the message digest is not updated. The default is for the stream to be on.

Note that digest objects can compute only one digest (see `MessageDigest`), so that in order to compute intermediate digests, a caller should retain a handle onto the digest object, and clone it for each digest to be computed, leaving the original digest untouched.

Implementation Note:
  This implementation only updates the message digest with data actually read from the input stream when it is turned on. This includes the various `read` methods, `transferTo`, `readAllBytes`, and `readNBytes`. Please note that data bypassed by the `skip` method are ignored. On the other hand, if the underlying stream supports the `mark` and `reset` methods, and the same data is read again after `reset`, then the message digest is updated again.
Since:
  1.2
See Also:
  - `MessageDigest`
  - `DigestOutputStream`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected MessageDigest`
`digest`
The message digest associated with this stream.

### Fields declared in class java.io.FilterInputStream

`in`

## Constructor Summary

Constructors
Constructor
Description
`DigestInputStream(InputStream stream, MessageDigest digest)`
Creates a digest input stream, using the specified input stream and message digest.

## Method Summary

Modifier and Type
Method
Description
`MessageDigest`
`getMessageDigest()`
Returns the message digest associated with this stream.
`void`
`on(boolean on)`
Turns the digest function on or off.
`int`
`read()`
Reads a byte, and updates the message digest (if the digest function is on).
`int`
`read(byte[] b, int off, int len)`
Reads into a byte array, and updates the message digest (if the digest function is on).
`void`
`setMessageDigest(MessageDigest digest)`
Associates the specified message digest with this stream.
`String`
`toString()`
Prints a string representation of this digest input stream and its associated message digest object.

### Methods declared in class java.io.FilterInputStream

`available, close, mark, markSupported, read, reset, skip`

### Methods declared in class java.io.InputStream

`nullInputStream, readAllBytes, readNBytes, readNBytes, skipNBytes, transferTo`

### Methods declared in class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### digest

protected MessageDigest digest
The message digest associated with this stream.

## Constructor Details

### DigestInputStream

public DigestInputStream(InputStream stream, MessageDigest digest)
Creates a digest input stream, using the specified input stream and message digest.

Parameters:
  `stream` - the input stream.
  `digest` - the message digest to associate with this stream.

## Method Details

### getMessageDigest

public MessageDigest getMessageDigest()
Returns the message digest associated with this stream.

Returns:
  the message digest associated with this stream.
See Also:
  - `setMessageDigest(java.security.MessageDigest)`

### setMessageDigest

public void setMessageDigest(MessageDigest digest)
Associates the specified message digest with this stream.

Parameters:
  `digest` - the message digest to be associated with this stream.
See Also:
  - `getMessageDigest()`

### read

public int read() throws IOException
Reads a byte, and updates the message digest (if the digest function is on). That is, this method reads a byte from the input stream, blocking until the byte is actually read. If the digest function is on (see `on`), this method will then call `update` on the message digest associated with this stream, passing it the byte read.

Overrides:
  `read` in class `FilterInputStream`
Returns:
  the byte read.
Throws:
  `IOException` - if an I/O error occurs.
See Also:
  - `MessageDigest.update(byte)`

### read

public int read(byte[] b, int off, int len) throws IOException
Reads into a byte array, and updates the message digest (if the digest function is on). That is, this method reads up to `len` bytes from the input stream into the array `b`, starting at offset `off`. This method blocks until the data is actually read. If the digest function is on (see `on`), this method will then call `update` on the message digest associated with this stream, passing it the data.

Overrides:
  `read` in class `FilterInputStream`
Parameters:
  `b` - the array into which the data is read.
  `off` - the starting offset into `b` of where the data should be placed.
  `len` - the maximum number of bytes to be read from the input stream into b, starting at offset `off`.
Returns:
  the actual number of bytes read. This is less than `len` if the end of the stream is reached prior to reading `len` bytes. -1 is returned if no bytes were read because the end of the stream had already been reached when the call was made.
Throws:
  `IOException` - if an I/O error occurs.
See Also:
  - `MessageDigest.update(byte[], int, int)`

### on

public void on(boolean on)
Turns the digest function on or off. The default is on. When it is on, a call to one of the `read` methods results in an update on the message digest. But when it is off, the message digest is not updated.

Parameters:
  `on` - `true` to turn the digest function on, `false` to turn it off.

### toString

public String toString()
Prints a string representation of this digest input stream and its associated message digest object.

Overrides:
  `toString` in class `Object`
Returns:
  a string representation of the object